#include <cstdio>

struct point
{
    int x, y;
};

const int MAXN = 200 + 10;

int W, H, S, N;
point p[MAXN];

void read()
{
    scanf("%d%d%d", &W, &H, &S);
    scanf("%d", &N);
    for (int i = 0; i < N; i++)
    {
        scanf("%d%d", &p[i].x, &p[i].y);
    }
}

bool solve()
{
    for (int x = 0; x + S <= W; x++)
    {
        for (int y = 0; y + S <= H; y++)
        {
            bool ok = true;
            for (int i = 0; i < N; i++)
            {
                if (p[i].x > x && p[i].x < x + S && p[i].y > y && p[i].y < y + S)
                {
                    ok = false;
                    break;
                }
            }
            if (ok)
            {
                return true;
            }
        }
    }
    return false;
}

int main()
{
    read();
    bool can = solve();
    if (can)
    {
        printf("YES\n");
    }
    else
    {
        printf("NO\n");
    }
    
    return 0;
}
