#include <cstdio>
#include <algorithm>

struct point
{
    int x, y;
};

const int MAXN = 200000 + 10;
const int MAXW = 1000 + 10;

int W, H, S, N;
point p[MAXN];
bool excr[MAXW][MAXW];

void read()
{
    scanf("%d%d%d", &W, &H, &S);
    scanf("%d", &N);
    for (int i = 0; i < N; i++)
    {
        scanf("%d%d", &p[i].x, &p[i].y);
        excr[p[i].x][p[i].y] = 1;
    }
}

int dp[MAXW][MAXW];

bool solve()
{
    for (int x = 1; x <= W; x++)
    {
        for (int y = 1; y <= H; y++)
        {
            if (excr[x - 1][y - 1])
            {
                dp[x][y] = 1;
            }
            else
            {
                dp[x][y] = std::min(dp[x - 1][y - 1], std::min(dp[x - 1][y], dp[x][y - 1])) + 1;
            }
            if (dp[x][y] == S)
            {
                return true;
            }
        }
    }
    return false;
}

int main()
{
    read();
    bool can = solve();
    if (can)
    {
        printf("YES\n");
    }
    else
    {
        printf("NO\n");
    }
    
    return 0;
}
