
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <conio.h>
using namespace std;

const int MAX_SEQ_LEN = 100000 + 5;
const int MAX_CMD_LEN = 1000000 + 5;

int len;
int perm[MAX_SEQ_LEN];
int src_perm[MAX_SEQ_LEN];
int dst_perm[MAX_SEQ_LEN];

int rev_cnt;
pair<int, int> rev_arg[MAX_CMD_LEN];

void read() {
    scanf("%d", &len);
    for (int i = 0; i < len; ++i) scanf("%d", &src_perm[i]);
    for (int i = 0; i < len; ++i) scanf("%d", &dst_perm[i]);
}

void sort(int perm[]) {
    rev_cnt = 0;
    static int where[MAX_SEQ_LEN];
    for (int i = 0; i < len; ++i) where[perm[i]] = i;
    for (int i = 0; i < len; ++i)
        if (perm[i] != i + 1) {
            int old_pos = i;
            int new_pos = where[i + 1];

            rev_arg[rev_cnt++] = make_pair(old_pos, new_pos);
            if (new_pos - old_pos + 1 > 3)
                rev_arg[rev_cnt++] = make_pair(old_pos + 1, new_pos - 1);

            where[perm[old_pos]] = new_pos;
            where[perm[new_pos]] = old_pos;
            swap(perm[old_pos], perm[new_pos]);
        }
}

void solve() {
    static int where[MAX_SEQ_LEN];
    for (int i = 0; i < len; ++i) where[dst_perm[i]] = i + 1;
    for (int i = 0; i < len; ++i) perm[i] = where[src_perm[i]];

    sort(perm);
    printf("%d\n", rev_cnt);
    for (int i = 0; i < rev_cnt; ++i)
        printf("%d %d\n", rev_arg[i].first + 1, rev_arg[i].second + 1);
}

int main() {
    read();
    solve();
    return 0;
}
