#include <stdio.h>
#include <string.h>

#define MMAX 101
#define AMAX 7
#define BMAX 5
#define NMAX 10

#define INF 666666666
#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))

int A[NMAX], B[NMAX], Tmin[MMAX][BMAX][BMAX][BMAX], t[NMAX], tt[NMAX];
int i, j, k, N, M, vmin;

int dinamica(void)
{
	int vmin, i, k;

	for (k = 0; k <= M; k++)
		for (t[0] = 0; t[0] < BMAX; t[0]++)
			for (t[1] = 0; t[1] < BMAX; t[1]++)
				for (t[2] = 0; t[2] < BMAX; t[2]++)
					Tmin[k][t[0]][t[1]][t[2]] = INF;

	Tmin[0][0][0][0] = 0;
	for (k = 0; k < M; k++)
		for (t[0] = BMAX - 1; t[0] >= 0; t[0]--)
			for (t[1] = BMAX - 1; t[1] >= 0; t[1]--)
				for (t[2] = BMAX - 1; t[2] >= 0; t[2]--)
					if (Tmin[k][t[0]][t[1]][t[2]] < INF)
					{
						Tmin[k][max(0, t[0]-1)][max(0, t[1]-1)][max(0, t[2]-1)] = min(Tmin[k][max(0, t[0]-1)][max(0, t[1]-1)][max(0, t[2]-1)],
																			1 + Tmin[k][t[0]][t[1]][t[2]]);

						memcpy(tt, t, sizeof(t));

						for (i = 0; i < N; i++)
							if (t[i] == 0)
							{
								tt[i] = B[i] + 1;
								Tmin[min(k + A[i], M)][max(0, tt[0]-1)][max(0, tt[1]-1)][max(0, tt[2]-1)] = min(Tmin[min(k + A[i], M)][max(0, tt[0]-1)][max(0, tt[1]-1)][max(0, tt[2]-1)], 1 + Tmin[k][t[0]][t[1]][t[2]]);
								tt[i] = 0;
							}
					}

	vmin = INF;

	for (t[0] = 0; t[0] < BMAX; t[0]++)
		for (t[1] = 0; t[1] < BMAX; t[1]++)
			for (t[2] = 0; t[2] < BMAX; t[2]++)
				if (Tmin[M][t[0]][t[1]][t[2]] < vmin)
					vmin = Tmin[M][t[0]][t[1]][t[2]];

	//printf("dinamica: %d\n", vmin);

	return vmin;
}

int greedy(void)
{
	int nsent, T, Amax, Bmin, Bmax, k;

	nsent = T = 0;
	memset(t, 0, sizeof(t));

	while (nsent < M)
	{
		/*
		printf("[greedy] T=%d, nsent=%d => ", T, nsent);
		for (i = 0; i < N; i++)
			printf(" %d", t[i]);
		printf("\n");
		*/

		k = -1;
		Amax = 0;

		for (i = 0; i < N; i++)
			if (t[i] == 0)
			{
				if (A[i] > Amax)
				{
					Amax = A[i];
					Bmin = Bmax = B[i];
					k = i;
				}
				else
				if (A[i] == Amax && B[i] > Bmax)
				{
					Amax = A[i];
					Bmin = Bmax = B[i];
					k = i;
				}
			}

		if (k >= 0)
		{
			nsent += A[k];
			t[k] = B[k] + 1;

			//printf("[greedy] T=%d => sending %d packets with TCP stream %d\n", T, A[k], k);
		}
		else
		{
			//printf("[greedy] T=%d => waiting\n", T);
		}

		T++;

		for (i = 0; i < N; i++)
			t[i] = max(0, t[i] - 1);
	}

	//printf("greedy: %d\n", T);

	return T;
}

int main()
{
	int td, tg, nd = 0, ng = 0, neq = 0;

	//freopen("tcp.in", "r", stdin);
	//scanf("%d", &M);

	N = 3;
	M = 100;
	/*
	for (i = 0; i < N; i++)
		scanf("%d %d", &A[i], &B[i]);
	*/

	for (A[0] = 1; A[0] <= 7; A[0]++)
		for (A[1] = 1; A[1] <= 7; A[1]++)
			for (A[2] = 1; A[2] <= AMAX; A[2]++)
				for (B[0] = 0; B[0] < BMAX; B[0]++)
					for (B[1] = 0; B[1] < BMAX; B[1]++)
						for (B[2] = 0; B[2] < BMAX; B[2]++)
						{
								td = dinamica();
								tg = greedy();

								if (td < tg) nd++;
								else if (td == tg) neq++;
								else ng++;

								printf("(%d,%d) (%d,%d) (%d,%d) => (%d, %d, %d)\n", A[0], B[0], A[1], B[1], A[2], B[2], nd, neq, ng);
						}

	return 0;
}
